﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class _Default : QPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    private DataTable m_dataSource;


    private DataTable DataSource
    {
        get
        {
            if (ViewState["DataSource"] != null)
            {
                m_dataSource = (DataTable) ViewState["DataSource"];

                return m_dataSource;
            }

            m_dataSource = new DataTable();

            m_dataSource.Columns.Add(new DataColumn("Name"));
            m_dataSource.Columns.Add(new DataColumn("Description"));
            
            for (int i = 0; i < 10; i++)
            {
                var row = m_dataSource.NewRow();

                row["Name"] = i.ToString();
                row["Description"] = "Description " + i;

                m_dataSource.Rows.Add(row);

            }

            ViewState["DataSource"] = m_dataSource;

            return m_dataSource;
        }
    }

    protected void RadGrid1_OnNeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = DataSource;
    }

    protected void RadGrid1_OnItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.DeleteCommandName)
        {
            DataSource.Rows.Remove(m_dataSource.Rows[e.Item.ItemIndex]);

            RadGrid1.Rebind();
        }
        else if (e.CommandName == RadGrid.UpdateCommandName)
        {
            var row = DataSource.Rows[e.Item.ItemIndex];
            row["Name"] = e.Item.ItemIndex + " " + DateTime.Now.Ticks;
            row["Description"] = "Description " + e.Item.ItemIndex + " " + DateTime.Now.Ticks;

            RadGrid1.Rebind();
        }
    }
}